Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.imageio.metadata
Class IIOMetadataNode

    java.lang.Object
      javax.imageio.metadata.IIOMetadataNode

All Implemented Interfaces:
  Element, Node, NodeList

    public class IIOMetadataNode

extends Object
implements Element, NodeList

A class representing a node in a meta-data tree, which implements the `org.w3c.dom.Element` interface and additionally allows for the storage of non-textual objects via the `getUserObject` and `setUserObject` methods.

This class is not intended to be used for general XML processing. In particular, `Element` nodes created within the Image I/O API are not compatible with those created by Sun's standard implementation of the `org.w3.dom` API. In particular, the implementation is tuned for simple uses and may not perform well for intensive processing.

Namespaces are ignored in this implementation. The terms "tag name" and "node name" are always considered to be synonymous.

See Also:
  `IIOMetadata.getAsTree(java.lang.String)`, `IIOMetadata.setFromTree(java.lang.String, org.w3c.dom.Node)`, `IIOMetadata.mergeTree(java.lang.String, org.w3c.dom.Node)`

Field Summary

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`IIOMetadataNode()` Constructs an empty `IIOMetadataNode`.
`IIOMetadataNode(String nodeName)` Constructs an `IIOMetadataNode` with a given node name.

Method Summary
`Node` | `appendChild(Node newChild)` Adds the node `newChild` to the end of the list of children of this node.
`Node` | `cloneNode(boolean deep)` Returns a duplicate of this node.
`short` | `compareDocumentPosition(Node other)` Compares the reference node, i.e.
`String` | `getAttribute(String name)` Retrieves an attribute value by name.
`Attr` | `getAttributeNode(String name)` Retrieves an attribute node by name.
`Attr` | `getAttributeNodeNS(String namespaceURI, String localName)` Equivalent to `getAttributeNode(localName)`.
`String` | `getAttributeNS(String namespaceURI, String localName)` Equivalent to `getAttribute(localName)`.
`NamedNodeMap` | `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`String` | `getBaseURI()` The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI.
`NodeList` | `getChildNodes()` A `NodeList` that contains all children of this node.
`NodeList` | `getElementsByTagName(String name)` Returns a `NodeList` of all descendant `Elements` with a given tag name, in document order.
`NodeList` | `getElementsByTagNameNS(String namespaceURI, String localName)` Equivalent to `getElementsByTagName(localName)`.
`Object` | `getFeature(String feature, String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
`Node` | `getFirstChild()` Returns the first child of this node, or `null` if the node has no children.
`Node` | `getLastChild()` Returns the last child of this node, or `null` if the node has no children.
`int` | `getLength()` The number of nodes in the list.
`String` | `getLocalName()` Equivalent to `getNodeName`.
`String` | `getNamespaceURI()` Returns `null`, since namespaces are not supported.
`Node` | `getNextSibling()` Returns the next sibling of this node, or `null` if the node has no next sibling.
`String` | `getNodeName()` Returns the node name associated with this node.
`short` | `getNodeType()` Returns the node type, which is always `ELEMENT_NODE`.
`String` | `getNodeValue()` The value of this node, depending on its type; see the table above.
`Document` | `getOwnerDocument()` Returns `null`, since `IIOMetadataNode`s do not belong to any `Document`.
`Node` | `getParentNode()` Returns the parent of this node.
`String` | `getPrefix()` Returns `null`, since namespaces are not supported.
`Node` | `getPreviousSibling()` Returns the previous sibling of this node, or `null` if this node has no previous sibling.
`TypeInfo` | `getSchemaTypeInfo()` The type information associated with this element.
`String` | `getTagName()` The name of the element.
`String` | `getTextContent()` This attribute returns the text content of this node and its descendants.
`Object` | `getUserData(String key)` Retrieves the object associated to a key on a this node.
`Object` | `getUserObject()` Returns the `Object` value associated with this node.
`boolean` | `hasAttribute(String name)` Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
`boolean` | `hasAttributeNS(String namespaceURI, String localName)` Equivalent to `hasAttribute(localName)`.
`boolean` | `hasAttributes()` Returns whether this node (if it is an element) has any attributes.
`boolean` | `hasChildNodes()` Returns `true` if this node has child nodes.
`Node` | `insertBefore(Node newChild, Node refChild)` Inserts the node `newChild` before the existing child node `refChild`.
`boolean` | `isDefaultNamespace(String namespaceURI)` This method checks if the specified `namespaceURI` is the default namespace or not.
`boolean` | `isEqualNode(Node node)` Tests whether two nodes are equal.
`boolean` | `isSameNode(Node node)` Returns whether this node is the same node as the given one.
`boolean` | `isSupported(String feature, String version)` Returns `false` since DOM features are not supported.
`Node` | `item(int index)` Returns the `index`th item in the collection.
`String` | `lookupNamespaceURI(String prefix)` Look up the namespace URI associated to the given prefix, starting from this node.
`String` | `lookupPrefix(String namespaceURI)` Look up the prefix associated to the given namespace URI, starting from this node.
`void` | `normalize()` Does nothing, since `IIOMetadataNode`s do not contain `Text` children.
`void` | `removeAttribute(String name)` Removes an attribute by name.
`Attr` | `removeAttributeNode(Attr oldAttr)` Removes the specified attribute node.
`void` | `removeAttributeNS(String namespaceURI, String localName)` Equivalent to `removeAttribute(localName)`.
`Node` | `removeChild(Node oldChild)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node` | `replaceChild(Node newChild, Node oldChild)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void` | `setAttribute(String name, String value)` Adds a new attribute.
`Attr` | `setAttributeNode(Attr newAttr)` Adds a new attribute node.
`Attr` | `setAttributeNodeNS(Attr newAttr)` Equivalent to `setAttributeNode(newAttr)`.
`void` | `setAttributeNS(String namespaceURI, String qualifiedName, String value)` Equivalent to `setAttribute(qualifiedName, value)`.
`void` | `setIdAttribute(String name, boolean isId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
`void` | `setIdAttributeNode(Attr idAttr, boolean isId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
`void` | `setIdAttributeNS(String namespaceURI, String localName, boolean isId)` If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
`void` | `setNodeValue(String nodeValue)` The value of this node, depending on its type; see the table above.
`void` | `setPrefix(String prefix)` Does nothing, since namespaces are not supported.
`void` | `setTextContent(String textContent)` This attribute returns the text content of this node and its descendants.
`Object` | `setUserData(String key, Object data, UserDataHandler handler)` Associate an object to a key on this node.
`void` | `setUserObject(Object userObject)` Sets the value associated with this node.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IIOMetadataNode

    public IIOMetadataNode()

  Constructs an empty `IIOMetadataNode`.

### IIOMetadataNode

    public IIOMetadataNode(String nodeName)

  Constructs an `IIOMetadataNode` with a given node name.

  Parameters:
    `nodeName` - the name of the node, as a `String`.

Method Detail

### getNodeName

    public String getNodeName()

  Returns the node name associated with this node.

  Specified by:
    `getNodeName` in interface `Node`
  Returns:
    the node name, as a `String`.

### getNodeValue

    public String getNodeValue()
                        throws DOMException

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.

  Specified by:
    `getNodeValue` in interface `Node`
  Throws:
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setNodeValue

    public void setNodeValue(String nodeValue)
                      throws DOMException

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.

  Specified by:
    `setNodeValue` in interface `Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly and if it is not defined to be `null`.

### getNodeType

    public short getNodeType()

  Returns the node type, which is always `ELEMENT_NODE`.

  Specified by:
    `getNodeType` in interface `Node`
  Returns:
    the `short` value `ELEMENT_NODE`.

### getParentNode

    public Node getParentNode()

  Returns the parent of this node. A `null` value indicates that the node is the root of its own tree. To add a node to an existing tree, use one of the `insertBefore`, `replaceChild`, or `appendChild` methods.

  Specified by:
    `getParentNode` in interface `Node`
  Returns:
    the parent, as a `Node`.
  See Also:
    `insertBefore(org.w3c.dom.Node, org.w3c.dom.Node)`, `replaceChild(org.w3c.dom.Node, org.w3c.dom.Node)`, `appendChild(org.w3c.dom.Node)`

### getChildNodes

    public NodeList getChildNodes()

  Description copied from interface: `Node`
  A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes.

  Specified by:
    `getChildNodes` in interface `Node`

### getFirstChild

    public Node getFirstChild()

  Returns the first child of this node, or `null` if the node has no children.

  Specified by:
    `getFirstChild` in interface `Node`
  Returns:
    the first child, as a `Node`, or `null`

### getLastChild

    public Node getLastChild()

  Returns the last child of this node, or `null` if the node has no children.

  Specified by:
    `getLastChild` in interface `Node`
  Returns:
    the last child, as a `Node`, or `null`.

### getPreviousSibling

    public Node getPreviousSibling()

  Returns the previous sibling of this node, or `null` if this node has no previous sibling.

  Specified by:
    `getPreviousSibling` in interface `Node`
  Returns:
    the previous sibling, as a `Node`, or `null`.

### getNextSibling

    public Node getNextSibling()

  Returns the next sibling of this node, or `null` if the node has no next sibling.

  Specified by:
    `getNextSibling` in interface `Node`
  Returns:
    the next sibling, as a `Node`, or `null`.

### getAttributes

    public NamedNodeMap getAttributes()

  Description copied from interface: `Node`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

  Specified by:
    `getAttributes` in interface `Node`

### getOwnerDocument

    public Document getOwnerDocument()

  Returns `null`, since `IIOMetadataNode`s do not belong to any `Document`.

  Specified by:
    `getOwnerDocument` in interface `Node`
  Returns:
    `null`.

### insertBefore

    public Node insertBefore(Node newChild,
                             Node refChild)

  Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.

  Specified by:
    `insertBefore` in interface `Node`
  Parameters:
    `newChild` - the `Node` to insert.
    `refChild` - the reference `Node`.
  Returns:
    the node being inserted.
  Throws:
    `IllegalArgumentException` - if `newChild` is `null`.

### replaceChild

    public Node replaceChild(Node newChild,
                             Node oldChild)

  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.

  Specified by:
    `replaceChild` in interface `Node`
  Parameters:
    `newChild` - the `Node` to insert.
    `oldChild` - the `Node` to be replaced.
  Returns:
    the node replaced.
  Throws:
    `IllegalArgumentException` - if `newChild` is `null`.

### removeChild

    public Node removeChild(Node oldChild)

  Removes the child node indicated by `oldChild` from the list of children, and returns it.

  Specified by:
    `removeChild` in interface `Node`
  Parameters:
    `oldChild` - the `Node` to be removed.
  Returns:
    the node removed.
  Throws:
    `IllegalArgumentException` - if `oldChild` is `null`.

### appendChild

    public Node appendChild(Node newChild)

  Adds the node `newChild` to the end of the list of children of this node.

  Specified by:
    `appendChild` in interface `Node`
  Parameters:
    `newChild` - the `Node` to insert.
  Returns:
    the node added.
  Throws:
    `IllegalArgumentException` - if `newChild` is `null`.

### hasChildNodes

    public boolean hasChildNodes()

  Returns `true` if this node has child nodes.

  Specified by:
    `hasChildNodes` in interface `Node`
  Returns:
    `true` if this node has children.

### cloneNode

    public Node cloneNode(boolean deep)

  Returns a duplicate of this node. The duplicate node has no parent (`getParentNode` returns `null`). If a shallow clone is being performed (`deep` is `false`), the new node will not have any children or siblings. If a deep clone is being performed, the new node will form the root of a complete cloned subtree.

  Specified by:
    `cloneNode` in interface `Node`
  Parameters:
    `deep` - if `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself.
  Returns:
    the duplicate node.

### normalize

    public void normalize()

  Does nothing, since `IIOMetadataNode`s do not contain `Text` children.

  Specified by:
    `normalize` in interface `Node`

### isSupported

    public boolean isSupported(String feature,
                               String version)

  Returns `false` since DOM features are not supported.

  Specified by:
    `isSupported` in interface `Node`
  Parameters:
    `feature` - a `String`, which is ignored.
    `version` - a `String`, which is ignored.
  Returns:
    `false`.

### getNamespaceURI

    public String getNamespaceURI()
                           throws DOMException

  Returns `null`, since namespaces are not supported.

  Specified by:
    `getNamespaceURI` in interface `Node`
  Throws:
    `DOMException`

### getPrefix

    public String getPrefix()

  Returns `null`, since namespaces are not supported.

  Specified by:
    `getPrefix` in interface `Node`
  Returns:
    `null`.
  See Also:
    `setPrefix(java.lang.String)`

### setPrefix

    public void setPrefix(String prefix)

  Does nothing, since namespaces are not supported.

  Specified by:
    `setPrefix` in interface `Node`
  Parameters:
    `prefix` - a `String`, which is ignored.
  See Also:
    `getPrefix()`

### getLocalName

    public String getLocalName()

  Equivalent to `getNodeName`.

  Specified by:
    `getLocalName` in interface `Node`
  Returns:
    the node name, as a `String`.

### getTagName

    public String getTagName()

  Description copied from interface: `Element`
  The name of the element. If `Node.localName` is different from `null`, this attribute is a qualified name. For example, in:

       <elementExample id="demo"> ...
       </elementExample> ,

  `tagName` has the value `"elementExample"`. Note that this is case-preserving in XML, as are all of the operations of the DOM. The HTML DOM returns the `tagName` of an HTML element in the canonical uppercase form, regardless of the case in the source HTML document.

  Specified by:
    `getTagName` in interface `Element`

### getAttribute

    public String getAttribute(String name)

  Description copied from interface: `Element`
  Retrieves an attribute value by name.

  Specified by:
    `getAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to retrieve.
  Returns:
    The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

### getAttributeNS

    public String getAttributeNS(String namespaceURI,
                                 String localName)

  Equivalent to `getAttribute(localName)`.

  Specified by:
    `getAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.
  See Also:
    `setAttributeNS(java.lang.String, java.lang.String, java.lang.String)`

### setAttribute

    public void setAttribute(String name,
                             String value)

  Description copied from interface: `Element`
  Adds a new attribute. If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute.
  To set an attribute with a qualified name and namespace URI, use the `setAttributeNS` method.

  Specified by:
    `setAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to create or alter.
    `value` - Value to set in string form.

### setAttributeNS

    public void setAttributeNS(String namespaceURI,
                               String qualifiedName,
                               String value)

  Equivalent to `setAttribute(qualifiedName, value)`.

  Specified by:
    `setAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to create or alter.
    `qualifiedName` - The qualified name of the attribute to create or alter.
    `value` - The value to set in string form.
  See Also:
    `getAttributeNS(java.lang.String, java.lang.String)`

### removeAttribute

    public void removeAttribute(String name)

  Description copied from interface: `Element`
  Removes an attribute by name. If a default value for the removed attribute is defined in the DTD, a new attribute immediately appears with the default value as well as the corresponding namespace URI, local name, and prefix when applicable. The implementation may handle default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.
  If no attribute with this name is found, this method has no effect.
  To remove an attribute by local name and namespace URI, use the `removeAttributeNS` method.

  Specified by:
    `removeAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to remove.

### removeAttributeNS

    public void removeAttributeNS(String namespaceURI,
                                  String localName)

  Equivalent to `removeAttribute(localName)`.

  Specified by:
    `removeAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to remove.
    `localName` - The local name of the attribute to remove.

### getAttributeNode

    public Attr getAttributeNode(String name)

  Description copied from interface: `Element`
  Retrieves an attribute node by name.
  To retrieve an attribute node by qualified name and namespace URI, use the `getAttributeNodeNS` method.

  Specified by:
    `getAttributeNode` in interface `Element`
  Parameters:
    `name` - The name (`nodeName`) of the attribute to retrieve.
  Returns:
    The `Attr` node with the specified name ( `nodeName`) or `null` if there is no such attribute.

### getAttributeNodeNS

    public Attr getAttributeNodeNS(String namespaceURI,
                                   String localName)

  Equivalent to `getAttributeNode(localName)`.

  Specified by:
    `getAttributeNodeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    The `Attr` node with the specified attribute local name and namespace URI or `null` if there is no such attribute.
  See Also:
    `setAttributeNodeNS(org.w3c.dom.Attr)`

### setAttributeNode

    public Attr setAttributeNode(Attr newAttr)
                          throws DOMException

  Description copied from interface: `Element`
  Adds a new attribute node. If an attribute with that name ( `nodeName`) is already present in the element, it is replaced by the new one. Replacing an attribute node by itself has no effect.
  To add a new attribute node with a qualified name and namespace URI, use the `setAttributeNodeNS` method.

  Specified by:
    `setAttributeNode` in interface `Element`
  Parameters:
    `newAttr` - The `Attr` node to add to the attribute list.
  Returns:
    If the `newAttr` attribute replaces an existing attribute, the replaced `Attr` node is returned, otherwise `null` is returned.
  Throws:
    `DOMException` - WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.

### setAttributeNodeNS

    public Attr setAttributeNodeNS(Attr newAttr)

  Equivalent to `setAttributeNode(newAttr)`.

  Specified by:
    `setAttributeNodeNS` in interface `Element`
  Parameters:
    `newAttr` - The `Attr` node to add to the attribute list.
  Returns:
    If the `newAttr` attribute replaces an existing attribute with the same local name and namespace URI, the replaced `Attr` node is returned, otherwise `null` is returned.
  See Also:
    `getAttributeNodeNS(java.lang.String, java.lang.String)`

### removeAttributeNode

    public Attr removeAttributeNode(Attr oldAttr)

  Description copied from interface: `Element`
  Removes the specified attribute node. If a default value for the removed `Attr` node is defined in the DTD, a new node immediately appears with the default value as well as the corresponding namespace URI, local name, and prefix when applicable. The implementation may handle default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.

  Specified by:
    `removeAttributeNode` in interface `Element`
  Parameters:
    `oldAttr` - The `Attr` node to remove from the attribute list.
  Returns:
    The `Attr` node that was removed.

### getElementsByTagName

    public NodeList getElementsByTagName(String name)

  Description copied from interface: `Element`
  Returns a `NodeList` of all descendant `Elements` with a given tag name, in document order.

  Specified by:
    `getElementsByTagName` in interface `Element`
  Parameters:
    `name` - The name of the tag to match on. The special value "*" matches all tags.
  Returns:
    A list of matching `Element` nodes.

### getElementsByTagNameNS

    public NodeList getElementsByTagNameNS(String namespaceURI,
                                           String localName)

  Equivalent to `getElementsByTagName(localName)`.

  Specified by:
    `getElementsByTagNameNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the elements to match on. The special value "*" matches all namespaces.
    `localName` - The local name of the elements to match on. The special value "*" matches all local names.
  Returns:
    A new `NodeList` object containing all the matched `Elements`.

### hasAttributes

    public boolean hasAttributes()

  Description copied from interface: `Node`
  Returns whether this node (if it is an element) has any attributes.

  Specified by:
    `hasAttributes` in interface `Node`
  Returns:
    Returns `true` if this node has any attributes, `false` otherwise.

### hasAttribute

    public boolean hasAttribute(String name)

  Description copied from interface: `Element`
  Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.

  Specified by:
    `hasAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to look for.
  Returns:
    `true` if an attribute with the given name is specified on this element or has a default value, `false` otherwise.

### hasAttributeNS

    public boolean hasAttributeNS(String namespaceURI,
                                  String localName)

  Equivalent to `hasAttribute(localName)`.

  Specified by:
    `hasAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to look for.
    `localName` - The local name of the attribute to look for.
  Returns:
    `true` if an attribute with the given local name and namespace URI is specified or has a default value on this element, `false` otherwise.

### getLength

    public int getLength()

  Description copied from interface: `NodeList`
  The number of nodes in the list. The range of valid child node indices is 0 to `length-1` inclusive.

  Specified by:
    `getLength` in interface `NodeList`

### item

    public Node item(int index)

  Description copied from interface: `NodeList`
  Returns the `index`th item in the collection. If `index` is greater than or equal to the number of nodes in the list, this returns `null`.

  Specified by:
    `item` in interface `NodeList`
  Parameters:
    `index` - Index into the collection.
  Returns:
    The node at the `index`th position in the `NodeList`, or `null` if that is not a valid index.

### getUserObject

    public Object getUserObject()

  Returns the `Object` value associated with this node.

  Returns:
    the user `Object`.
  See Also:
    `setUserObject(java.lang.Object)`

### setUserObject

    public void setUserObject(Object userObject)

  Sets the value associated with this node.

  Parameters:
    `userObject` - the user `Object`.
  See Also:
    `getUserObject()`

### setIdAttribute

    public void setIdAttribute(String name,
                               boolean isId)
                        throws DOMException

  Description copied from interface: `Element`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.
  To specify an attribute by local name and namespace URI, use the `setIdAttributeNS` method.

  Specified by:
    `setIdAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute.
    `isId` - Whether the attribute is a of type ID.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

### setIdAttributeNS

    public void setIdAttributeNS(String namespaceURI,
                                 String localName,
                                 boolean isId)
                          throws DOMException

  Description copied from interface: `Element`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.

  Specified by:
    `setIdAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute.
    `localName` - The local name of the attribute.
    `isId` - Whether the attribute is a of type ID.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

### setIdAttributeNode

    public void setIdAttributeNode(Attr idAttr,
                                   boolean isId)
                            throws DOMException

  Description copied from interface: `Element`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute . This affects the value of `Attr.isId` and the behavior of `Document.getElementById`, but does not change any schema that may be in use, in particular this does not affect the `Attr.schemaTypeInfo` of the specified `Attr` node. Use the value `false` for the parameter `isId` to undeclare an attribute for being a user-determined ID attribute.

  Specified by:
    `setIdAttributeNode` in interface `Element`
  Parameters:
    `idAttr` - The attribute node.
    `isId` - Whether the attribute is a of type ID.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if the specified node is not an attribute of this element.

### getSchemaTypeInfo

    public TypeInfo getSchemaTypeInfo()

  Description copied from interface: `Element`
  The type information associated with this element.

  Specified by:
    `getSchemaTypeInfo` in interface `Element`

### setUserData

    public Object setUserData(String key,
                              Object data,
                              UserDataHandler handler)

  Description copied from interface: `Node`
  Associate an object to a key on this node. The object can later be retrieved from this node by calling `getUserData` with the same key.

  Specified by:
    `setUserData` in interface `Node`
  Parameters:
    `key` - The key to associate the object to.
    `data` - The object to associate to the given key, or `null` to remove any existing association to that key.
    `handler` - The handler to associate to that key, or `null`.
  Returns:
    Returns the `DOMUserData` previously associated to the given key on this node, or `null` if there was none.

### getUserData

    public Object getUserData(String key)

  Description copied from interface: `Node`
  Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.

  Specified by:
    `getUserData` in interface `Node`
  Parameters:
    `key` - The key the object is associated to.
  Returns:
    Returns the `DOMUserData` associated to the given key on this node, or `null` if there was none.

### getFeature

    public Object getFeature(String feature,
                             String version)

  Description copied from interface: `Node`
  This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in . The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in . This method also allow the implementation to provide specialized objects which do not support the `Node` interface.

  Specified by:
    `getFeature` in interface `Node`
  Parameters:
    `feature` - The name of the feature requested. Note that any plus sign "+" prepended to the name of the feature will be ignored since it is not significant in the context of this method.
    `version` - This is the version number of the feature to test.
  Returns:
    Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.

### isSameNode

    public boolean isSameNode(Node node)

  Description copied from interface: `Node`
  Returns whether this node is the same node as the given one.
  This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangeably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.

  Specified by:
    `isSameNode` in interface `Node`
  Parameters:
    `node` - The node to test against.
  Returns:
    Returns `true` if the nodes are the same, `false` otherwise.

### isEqualNode

    public boolean isEqualNode(Node node)

  Description copied from interface: `Node`
  Tests whether two nodes are equal.
  This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode()`. All nodes that are the same will also be equal, though the reverse may not be true.
  Two nodes are equal if and only if the following conditions are satisfied:
  - The two nodes are of the same type.
  - The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` . This is: they are both `null`, or they have the same length and are character for character identical.
  - The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.
  - The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
  For two `DocumentType` nodes to be equal, the following conditions must also be satisfied:
  - The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.
  - The `entities` `NamedNodeMaps` are equal.
  - The `notations` `NamedNodeMaps` are equal.
  On the other hand, the following do not affect equality: the `ownerDocument`, `baseURI`, and `parentNode` attributes, the `specified` attribute for `Attr` nodes, the `schemaTypeInfo` attribute for `Attr` and `Element` nodes, the `Text.isElementContentWhitespace` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.

  Note: As a general rule, anything not mentioned in the description above is not significant in consideration of equality checking. Note that future versions of this specification may take into account more attributes and implementations conform to this specification are expected to be updated accordingly.

  Specified by:
    `isEqualNode` in interface `Node`
  Parameters:
    `node` - The node to compare equality with.
  Returns:
    Returns `true` if the nodes are equal, `false` otherwise.

### lookupNamespaceURI

    public String lookupNamespaceURI(String prefix)

  Description copied from interface: `Node`
  Look up the namespace URI associated to the given prefix, starting from this node.
  See for details on the algorithm used by this method.

  Specified by:
    `lookupNamespaceURI` in interface `Node`
  Parameters:
    `prefix` - The prefix to look for. If this parameter is `null`, the method will return the default namespace URI if any.
  Returns:
    Returns the associated namespace URI or `null` if none is found.

### isDefaultNamespace

    public boolean isDefaultNamespace(String namespaceURI)

  Description copied from interface: `Node`
  This method checks if the specified `namespaceURI` is the default namespace or not.

  Specified by:
    `isDefaultNamespace` in interface `Node`
  Parameters:
    `namespaceURI` - The namespace URI to look for.
  Returns:
    Returns `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.

### lookupPrefix

    public String lookupPrefix(String namespaceURI)

  Description copied from interface: `Node`
  Look up the prefix associated to the given namespace URI, starting from this node. The default namespace declarations are ignored by this method.
  See for details on the algorithm used by this method.

  Specified by:
    `lookupPrefix` in interface `Node`
  Parameters:
    `namespaceURI` - The namespace URI to look for.
  Returns:
    Returns an associated namespace prefix if found or `null` if none is found. If more than one prefix are associated to the namespace prefix, the returned namespace prefix is implementation dependent.

### getTextContent

    public String getTextContent()
                          throws DOMException

  Description copied from interface: `Node`
  This attribute returns the text content of this node and its descendants. When it is defined to be `null`, setting it has no effect. On setting, any possible children this node may have are removed and, if it the new string is not empty or `null`, replaced by a single `Text` node containing the string this attribute is set to.
  On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content (see the attribute `Text.isElementContentWhitespace`). Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
  The string returned is made of the text content of this node depending on its type, as defined below:

  Node type | Content
  --- | ---
  ELEMENT_NODE, ATTRIBUTE_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes. This is the empty string if the node has no children.
  TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
  DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

  Specified by:
    `getTextContent` in interface `Node`
  Throws:
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setTextContent

    public void setTextContent(String textContent)
                        throws DOMException

  Description copied from interface: `Node`
  This attribute returns the text content of this node and its descendants. When it is defined to be `null`, setting it has no effect. On setting, any possible children this node may have are removed and, if it the new string is not empty or `null`, replaced by a single `Text` node containing the string this attribute is set to.
  On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content (see the attribute `Text.isElementContentWhitespace`). Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
  The string returned is made of the text content of this node depending on its type, as defined below:

  Node type | Content
  --- | ---
  ELEMENT_NODE, ATTRIBUTE_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes. This is the empty string if the node has no children.
  TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
  DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

  Specified by:
    `setTextContent` in interface `Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

### compareDocumentPosition

    public short compareDocumentPosition(Node other)
                                  throws DOMException

  Description copied from interface: `Node`
  Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.

  Specified by:
    `compareDocumentPosition` in interface `Node`
  Parameters:
    `other` - The node to compare against the reference node.
  Returns:
    Returns how the node is positioned relatively to the reference node.
  Throws:
    `DOMException` - NOT_SUPPORTED_ERR: when the compared nodes are from different DOM implementations that do not coordinate to return consistent implementation-specific results.

### getBaseURI

    public String getBaseURI()

  Description copied from interface: `Node`
  The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI. This value is computed as described in . However, when the `Document` supports the feature "HTML" [DOM Level 2 HTML] , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `Document` interface otherwise.

  Specified by:
    `getBaseURI` in interface `Node`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.